#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->sphereRadio->setChecked(true);
    ui->functionEdit->setEnabled(false);
    ui->fovSlider->setMinimum(5);
    ui->fovSlider->setMaximum(100);
    ui->fovSlider->setSliderPosition(66);

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    bool ok = true;

    int resolution;
    int *nv = (int*)malloc(2);
    int *nt = (int*)malloc(2);

    double minX, minY, minZ, maxX, maxY, maxZ;
    double fromX, fromY, fromZ;
    double fov;

    minX = ui->xMinEdit->text().toDouble(&ok);
    if (!ok){ minX = -1;
        minY = -1;
        minZ = -1;
        ok = true;}
    else{
        minY = minX;
        minZ = minX;
    }

    maxX = ui->xMaxEdit->text().toDouble(&ok);
    if (!ok){
        maxX = 1;
        maxY = 1;
        maxZ = 1;
        ok = true;
    }
    else{
        maxY = maxX;
        maxZ = maxX;
    }

    fromX = ui->fromXEdit->text().toDouble(&ok);
    if (!ok){
        fromX = 0;
        ok = true;
    }

    fromY = ui->fromYEdit->text().toDouble(&ok);
    if (!ok){
        fromY = 0.5;
        ok = true;
    }

    fromZ = ui->fromZEdit->text().toDouble(&ok);
    if (!ok){
        fromZ = -1.5;
        ok = true;
    }

    if (ui->fovSlider->value() > 4){
        fov = ui->fovSlider->maximum()- ui->fovSlider->value() + 5;
        ok = true;
    }
    else{
        fov = 60;
        ok = true;
    }


     if ( ui->resolutionEdit->text().toInt() > 14 )
        resolution = ui->resolutionEdit->text().toInt();
    else
        resolution = 15;

    if (ui->sphereRadio->isChecked())
        ui->openGLWidget->exampleMarching(0, resolution, nv, nt, minX, minY, minZ, maxX, maxY, maxZ, fromX, fromY, fromZ, fov);
    else if(ui->torusRadio->isChecked())
        ui->openGLWidget->exampleMarching(1, resolution, nv, nt, minX, minY, minZ, maxX, maxY, maxZ, fromX, fromY, fromZ, fov);
    else if(ui->otherButton->isChecked()){
        ui->openGLWidget->expression_str = ui->functionEdit->text().toStdString();
        if(ui->openGLWidget->parseExpression()){
            ui->openGLWidget->exampleMarching(2, resolution, nv, nt, minX, minY, minZ, maxX, maxY, maxZ, fromX, fromY, fromZ, fov);
        }
        else
            ui->openGLWidget->exampleMarching(0, resolution, nv, nt, minX, minY, minZ, maxX, maxY, maxZ, fromX, fromY, fromZ, fov);
    }

    ui->openGLWidget->load_scene_file("/home/pabloant/Desktop/ComputerGraphics/s3d-v53/platforms/qt/marching/marching/output.txt");
    ui->openGLWidget->update();
    ui->vertexLabel->setText(QString::number(*nv));
    ui->trianglesLabel->setText(QString::number(*nt));
}


void MainWindow::on_pushButton_2_clicked()
{
    QString filename;
    filename = QFileDialog::getOpenFileName(this,
        tr("Open Point Cload File"), "/home/jana", tr("Off Files (*.off)"));
}

void MainWindow::on_pointsButton_clicked()
{
    ui->openGLWidget->renderCloud();

    // here I need to use OpenGL to render points, not triangles, which is not implemented on the software of the course. This is probably not difficult,
    // but I'll leave it for later
    //ui->openGLWidget->load_scene_file("/home/pabloant/Desktop/ComputerGraphics/s3d-v53/platforms/qt/marching/marching/output.scn");
    //ui->openGLWidget->update();
}

void MainWindow::on_otherButton_toggled(bool checked)
{
    if (checked)
        ui->functionEdit->setEnabled(true);
    else
        ui->functionEdit->setEnabled(false);
}
